(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 9.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       157,          7]
NotebookDataLength[     19778,        556]
NotebookOptionsPosition[     18333,        511]
NotebookOutlinePosition[     19108,        537]
CellTagsIndexPosition[     19065,        534]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[TextData[{
 "Vamos a calcular en el cuepo \[DoubleStruckCapitalQ](\[Zeta]) con \[Zeta] \
una ra\[IAcute]z ",
 Cell[BoxData[
  FormBox["p", TraditionalForm]],
  FormatType->"TraditionalForm"],
 "-\[EAcute]sima de la unidad y ",
 Cell[BoxData[
  FormBox["p", TraditionalForm]],
  FormatType->"TraditionalForm"],
 " un primo de Fermat, de la forma ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    SuperscriptBox["2", "h"], "+", "1"}], TraditionalForm]],
  FormatType->"TraditionalForm"]
}], "Text",
 CellChangeTimes->{{3.621556645871601*^9, 3.621556703759354*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"p", " ", "=", " ", "257"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"r", " ", "=", " ", 
   RowBox[{"PrimitiveRoot", "[", "p", "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"h", " ", "=", " ", 
   RowBox[{"Log", "[", 
    RowBox[{"2", ",", 
     RowBox[{"p", "-", "1"}]}], "]"}]}], ";"}]}], "Input",
 CellChangeTimes->{{3.621445503323944*^9, 3.621445505975202*^9}, {
   3.621445536633605*^9, 3.621445543472047*^9}, {3.621445749773243*^9, 
   3.621445751475919*^9}, {3.621447104567913*^9, 3.621447132799082*^9}, {
   3.621448638302083*^9, 3.621448638390799*^9}, {3.6214495145349693`*^9, 
   3.621449515882579*^9}, {3.621555226631638*^9, 3.621555227510008*^9}, 
   3.621556707812375*^9, {3.6215598542462473`*^9, 3.621559885098914*^9}, {
   3.621562516387553*^9, 3.621562517331839*^9}, {3.621562582512148*^9, 
   3.6215625835507097`*^9}, {3.621562633963954*^9, 3.62156263402742*^9}, {
   3.62156291649474*^9, 3.621562916857671*^9}, {3.621565502698434*^9, 
   3.621565503230715*^9}}],

Cell[TextData[{
 "Sabemos que \[DoubleStruckCapitalQ](\[Zeta]) est\[AAcute] generado por \
\[Zeta] sobre \[DoubleStruckCapitalQ] y, de hecho que el conjunto ",
 Cell[BoxData[
  FormBox[
   RowBox[{"{", 
    RowBox[{"1", ",", "\[Zeta]", ",", 
     SuperscriptBox["\[Zeta]", "2"], ",", " ", "\[Ellipsis]", ",", " ", 
     SuperscriptBox["\[Zeta]", 
      RowBox[{"p", "-", "2"}]]}], "}"}], TraditionalForm]]],
 " es una base sobre \[DoubleStruckCapitalQ].\nCuando expresamos a los \
elementos del cuerpo en esa base es f\[AAcute]cil calcular: basta tener en \
cuenta que ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    SuperscriptBox["\[Zeta]", "k"], "=", 
    SuperscriptBox["\[Zeta]", 
     RowBox[{"Mod", "[", 
      RowBox[{"k", ",", " ", "p"}], "]"}]]}], TraditionalForm]]],
 " y que ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    SuperscriptBox["\[Zeta]", 
     RowBox[{"p", "-", "1"}]], "=", 
    RowBox[{
     RowBox[{"-", "1"}], "-", "\[Zeta]", "-", "\[CenterEllipsis]", "-", 
     SuperscriptBox["\[Zeta]", 
      RowBox[{"p", "-", "2"}]]}]}], TraditionalForm]]],
 ".\nLa funci\[OAcute]n ",
 StyleBox["reduce", "Input"],
 " agarra una expresi\[OAcute]n polinomial en \[Zeta] y la reduce a una en la \
base de \[DoubleStruckCapitalQ](\[Zeta])."
}], "Text",
 CellChangeTimes->{{3.621557826118999*^9, 3.621557846963497*^9}, 
   3.6215583404249268`*^9, {3.621558732313642*^9, 3.6215588075764713`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"SetAttributes", "[", 
   RowBox[{"reduce", ",", " ", "Listable"}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"reduce1", "[", "x_", "]"}], " ", ":=", " ", 
   RowBox[{
    RowBox[{"Expand", "[", "x", "]"}], " ", "/.", " ", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{
       SuperscriptBox["\[Zeta]", 
        RowBox[{"k_", "/;", 
         RowBox[{"k", ">", 
          RowBox[{"p", "-", "1"}]}]}]], "\[RuleDelayed]", " ", 
       SuperscriptBox["\[Zeta]", 
        RowBox[{"Mod", "[", 
         RowBox[{"k", ",", " ", "p"}], "]"}]]}], ",", " ", 
      RowBox[{
       SuperscriptBox["\[Zeta]", 
        RowBox[{"p", "-", "1"}]], "\[Rule]", 
       RowBox[{"-", 
        RowBox[{"Sum", "[", 
         RowBox[{
          SuperscriptBox["\[Zeta]", "i"], ",", 
          RowBox[{"{", 
           RowBox[{"i", ",", " ", "0", ",", " ", 
            RowBox[{"p", "-", "2"}]}], "}"}]}], "]"}]}]}]}], "}"}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"reduce", "[", "x_", "]"}], " ", ":=", " ", 
   RowBox[{"FixedPoint", "[", 
    RowBox[{"reduce1", ",", " ", "x"}], "]"}]}], ";"}]}], "Input",
 CellChangeTimes->{{3.621445594218755*^9, 3.621445692124577*^9}, {
  3.6214457258830643`*^9, 3.62144573270969*^9}, {3.621445993709441*^9, 
  3.6214460023661537`*^9}, {3.6215552403772917`*^9, 3.6215552837743483`*^9}}],

Cell[TextData[{
 "El grupo de Galois ",
 Cell[BoxData[
  FormBox["G", TraditionalForm]]],
 " de \[DoubleStruckCapitalQ](\[Zeta]) es c\[IAcute]clico de orden ",
 Cell[BoxData[
  FormBox[
   RowBox[{"p", "-", "1"}], TraditionalForm]]],
 ", isomorfo al grupo multiplicativo ",
 Cell[BoxData[
  FormBox[
   SuperscriptBox[
    SubscriptBox["\[DoubleStruckCapitalZ]", "p"], "\[Cross]"], 
   TraditionalForm]]],
 ". \nFijamos un generador, eligiendo un generdor de este \[UAcute]ltimo y \
recordando el isomorfismo ",
 Cell[BoxData[
  FormBox[
   RowBox[{"G", "\[Rule]"}], TraditionalForm]]],
 Cell[BoxData[
  FormBox[
   SuperscriptBox[
    SubscriptBox["\[DoubleStruckCapitalZ]", "p"], "\[Cross]"], 
   TraditionalForm]]],
 ". \nLa funci\[OAcute]n \[Sigma][i] es la potencia ",
 Cell[BoxData[
  FormBox["i", TraditionalForm]]],
 "-",
 "\[EAcute]sima de ese generador."
}], "Text",
 CellChangeTimes->{{3.621556715164138*^9, 3.6215567443351088`*^9}, {
  3.621558831722705*^9, 3.62155900924864*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"\[Sigma]", "[", "i_", "]"}], "[", "x_", "]"}], " ", ":=", " ", 
  RowBox[{"reduce", "[", 
   RowBox[{"x", " ", "/.", " ", 
    RowBox[{"\[Zeta]", " ", "\[Rule]", " ", 
     SuperscriptBox["\[Zeta]", 
      SuperscriptBox["r", "i"]]}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.621445503323944*^9, 3.621445505975202*^9}, {
   3.621445536633605*^9, 3.621445543472047*^9}, {3.621445749773243*^9, 
   3.621445751475919*^9}, {3.621447104567913*^9, 3.621447132799082*^9}, {
   3.621448638302083*^9, 3.621448638390799*^9}, {3.6214495145349693`*^9, 
   3.621449515882579*^9}, {3.621555226631638*^9, 3.621555227510008*^9}, 
   3.621556707812375*^9, 3.621558827244453*^9, {3.6215598830670023`*^9, 
   3.62155988988664*^9}}],

Cell[TextData[{
 "El periodo de Gauss nos da un elemento del cuerpo ",
 Cell[BoxData[
  FormBox[
   SuperscriptBox[
    RowBox[{"\[DoubleStruckCapitalQ]", "(", "\[Zeta]", ")"}], 
    SuperscriptBox["\[Sigma]", 
     SuperscriptBox["2", "i"]]], TraditionalForm]]],
 ":"
}], "Text",
 CellChangeTimes->{{3.621559036891079*^9, 3.6215590951031103`*^9}, {
  3.6215591859471483`*^9, 3.62155919678191*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"periodo", "[", "i_", "]"}], " ", ":=", " ", 
  RowBox[{"Sum", "[", 
   RowBox[{
    SuperscriptBox["\[Zeta]", 
     RowBox[{"Mod", "[", 
      RowBox[{
       SuperscriptBox["r", "j"], ",", " ", "p"}], "]"}]], ",", " ", 
    RowBox[{"{", 
     RowBox[{"j", ",", " ", "0", ",", " ", 
      RowBox[{"p", "-", "2"}], ",", " ", 
      SuperscriptBox["2", "i"]}], "}"}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.6214457614874773`*^9, 3.621445810380775*^9}, 
   3.6215591735135803`*^9}],

Cell[TextData[{
 "Calculamos una base para  ",
 Cell[BoxData[
  FormBox[
   SuperscriptBox[
    RowBox[{"\[DoubleStruckCapitalQ]", "(", "\[Zeta]", ")"}], 
    SuperscriptBox["\[Sigma]", 
     SuperscriptBox["2", "i"]]], TraditionalForm]]],
 " y armamos una tabla con los nombres de los elementos que aparecen:"
}], "Text",
 CellChangeTimes->{{3.62155920386248*^9, 3.6215592320561247`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"Clear", "[", "base", "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"base", "[", "0", "]"}], " ", "=", " ", "1"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"base", "[", 
     RowBox[{"k_", " ", "/;", " ", 
      RowBox[{"k", ">", "0"}]}], "]"}], " ", ":=", " ", 
    RowBox[{
     RowBox[{"base", "[", "k", "]"}], " ", "=", " ", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"base", "[", 
        RowBox[{"k", "-", "1"}], "]"}], ",", " ", 
       RowBox[{"reduce", "/@", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"base", "[", 
           RowBox[{"k", "-", "1"}], "]"}], 
          RowBox[{"periodo", "[", "k", "]"}]}], ")"}]}]}], "}"}]}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Clear", "[", "nombre", "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"nombre", "[", "0", "]"}], " ", "=", " ", "1"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"nombre", "[", 
    RowBox[{"k_", " ", "/;", " ", 
     RowBox[{"k", ">", "0"}]}], "]"}], ":=", " ", 
   RowBox[{
    RowBox[{"nombre", "[", "k", "]"}], " ", "=", " ", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"nombre", "[", 
       RowBox[{"k", "-", "1"}], "]"}], ",", " ", 
      RowBox[{
       SubscriptBox["w", "k"], 
       RowBox[{"nombre", "[", 
        RowBox[{"k", "-", "1"}], "]"}]}]}], "}"}]}]}], ";"}]}], "Input",
 CellChangeTimes->{{3.621445909458322*^9, 3.621445973372334*^9}, {
   3.621446010628035*^9, 3.621446033364752*^9}, {3.6214460921426086`*^9, 
   3.621446100219561*^9}, {3.6214463560317097`*^9, 3.621446356500574*^9}, {
   3.621555248602193*^9, 3.62155525098869*^9}, {3.621555761708647*^9, 
   3.6215557632673798`*^9}, {3.6215591199205112`*^9, 3.621559122092579*^9}, 
   3.621559160868338*^9, {3.6215592545300493`*^9, 3.6215592773277073`*^9}}],

Cell[TextData[{
 "Queremos que ",
 StyleBox["rewrite[k, e]", "Input"],
 " sea la escritura para el elemento ",
 StyleBox["e", "Input"],
 " del cuerpo ",
 Cell[BoxData[
  FormBox[
   SuperscriptBox[
    RowBox[{"\[DoubleStruckCapitalQ]", "(", "\[Zeta]", ")"}], 
    SuperscriptBox["\[Sigma]", 
     SuperscriptBox["2", "k"]]], TraditionalForm]]],
 " como combinaci\[OAcute]n lineal con coeficientes racionales de los \
elementos \[LineSeparator]de la base ",
 StyleBox["base[k]", "Input"],
 "de ese cuerpo. (La funci\[OAcute]n ",
 StyleBox["asume",
  FontSlant->"Italic"],
 " que el elemento ",
 StyleBox["e", "Input"],
 " efectivamente pertenece a ese cuerpo!)"
}], "Text",
 CellChangeTimes->{{3.62155929155063*^9, 3.621559482020156*^9}, 
   3.621559895835292*^9}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"Clear", "[", "rewrite", "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"rewrite", "[", 
   RowBox[{"k_", ",", " ", "e_"}], "]"}], " ", ":=", " ", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"a", ",", " ", "g", ",", " ", "sol"}], "}"}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"g", " ", "=", " ", 
      RowBox[{"Sum", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"a", "[", "t", "]"}], 
         RowBox[{
          RowBox[{"base", "[", "k", "]"}], "\[LeftDoubleBracket]", 
          RowBox[{"Sequence", "@@", "t"}], "\[RightDoubleBracket]"}]}], " ", 
        ",", " ", 
        RowBox[{"{", 
         RowBox[{"t", ",", " ", 
          RowBox[{"Tuples", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"1", ",", "2"}], "}"}], ",", " ", "k"}], "]"}]}], 
         "}"}]}], "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"sol", " ", "=", " ", 
      RowBox[{
       RowBox[{"Solve", "[", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{"#", "\[Equal]", "0"}], "&"}], " ", "/@", " ", 
          RowBox[{"CoefficientList", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"reduce", "[", "e", "]"}], "-", "g"}], ",", " ", 
            "\[Zeta]"}], "]"}]}], ",", "\[IndentingNewLine]", 
         RowBox[{"a", "/@", 
          RowBox[{"Tuples", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"1", ",", "2"}], "}"}], ",", " ", "k"}], "]"}]}]}], 
        "\[IndentingNewLine]", "]"}], "\[LeftDoubleBracket]", "1", 
       "\[RightDoubleBracket]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"Sum", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"a", "[", "t", "]"}], 
         RowBox[{
          RowBox[{"nombre", "[", "k", "]"}], "\[LeftDoubleBracket]", 
          RowBox[{"Sequence", "@@", "t"}], "\[RightDoubleBracket]"}]}], " ", 
        ",", " ", 
        RowBox[{"{", 
         RowBox[{"t", ",", " ", 
          RowBox[{"Tuples", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"1", ",", "2"}], "}"}], ",", " ", "k"}], "]"}]}], 
         "}"}]}], "]"}], " ", "/.", " ", "sol"}]}]}], "\[IndentingNewLine]", 
   "]"}]}]}], "Input",
 CellChangeTimes->{{3.62144618623829*^9, 3.6214463089150057`*^9}, {
   3.621446427616061*^9, 3.6214466184763117`*^9}, {3.621446728624674*^9, 
   3.621446844282137*^9}, {3.621555372901992*^9, 3.621555405266181*^9}, {
   3.621555668354887*^9, 3.6215557179895363`*^9}, {3.621555797451531*^9, 
   3.621555802723143*^9}, 3.621559248412285*^9, {3.6215594535091753`*^9, 
   3.621559457505413*^9}}],

Cell[TextData[{
 "El polinomio minimal de ",
 StyleBox["periodo[k] ", "Input"],
 "sobre ",
 Cell[BoxData[
  FormBox[
   SuperscriptBox[
    RowBox[{"\[DoubleStruckCapitalQ]", "(", "\[Zeta]", ")"}], 
    SuperscriptBox["\[Sigma]", 
     SuperscriptBox["2", 
      RowBox[{"k", "-", "1"}]]]], TraditionalForm]]]
}], "Text",
 CellChangeTimes->{{3.6215595533813887`*^9, 3.621559595780163*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"Clear", "[", 
   RowBox[{"\[Alpha]", ",", " ", "\[Beta]", ",", " ", "minimal"}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"\[Alpha]", "[", "k_", "]"}], " ", ":=", " ", 
   RowBox[{"Factor", "@", 
    RowBox[{"rewrite", "[", 
     RowBox[{"k", ",", " ", 
      RowBox[{
       RowBox[{
        RowBox[{"\[Sigma]", "[", 
         SuperscriptBox["2", 
          RowBox[{"k", "-", "1"}]], "]"}], "[", 
        RowBox[{"periodo", "[", "k", "]"}], "]"}], "+", 
       RowBox[{"periodo", "[", "k", "]"}]}]}], "]"}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"\[Beta]", "[", "k_", "]"}], " ", ":=", " ", 
   RowBox[{"Factor", "@", 
    RowBox[{"rewrite", "[", 
     RowBox[{"k", ",", " ", 
      RowBox[{
       RowBox[{
        RowBox[{"\[Sigma]", "[", 
         SuperscriptBox["2", 
          RowBox[{"k", "-", "1"}]], "]"}], "[", 
        RowBox[{"periodo", "[", "k", "]"}], "]"}], 
       RowBox[{"periodo", "[", "k", "]"}]}]}], "]"}]}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"minimal", "[", "k_", "]"}], " ", ":=", " ", 
   RowBox[{
    SuperscriptBox["X", "2"], "-", 
    RowBox[{
     RowBox[{"\[Alpha]", "[", "k", "]"}], "X"}], "+", 
    RowBox[{"\[Beta]", "[", "k", "]"}]}]}], ";"}]}], "Input",
 CellChangeTimes->{{3.621448874544548*^9, 3.621448902949284*^9}, {
  3.621555538306979*^9, 3.621555541964184*^9}, {3.6215557368377047`*^9, 
  3.621555739619895*^9}, {3.62155917087711*^9, 3.621559172212879*^9}, {
  3.621559598832137*^9, 3.621559605223403*^9}}],

Cell["Y, finalmente, la lista de los polinomios minimales:", "Text",
 CellChangeTimes->{{3.621559620099051*^9, 3.621559628664818*^9}}],

Cell[BoxData[
 RowBox[{"eqs", " ", "=", " ", 
  RowBox[{"ParallelTable", "[", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{
       SubscriptBox["f", "i"], "[", "X", "]"}], "\[Equal]", 
      RowBox[{"pretty", "[", 
       RowBox[{
        RowBox[{"minimal", "[", "i", "]"}], ",", " ", "X"}], "]"}]}], " ", "/.",
      " ", 
     RowBox[{"w", "\[Rule]", "x"}]}], ",", " ", 
    RowBox[{"{", 
     RowBox[{"i", ",", " ", "1", ",", " ", "h"}], "}"}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.621446882570096*^9, 3.621446898754395*^9}, {
   3.62144695264989*^9, 3.621446967394886*^9}, {3.6214470174801083`*^9, 
   3.6214470884723797`*^9}, {3.621447124526733*^9, 3.62144712532799*^9}, {
   3.621447221502337*^9, 3.621447224377687*^9}, {3.621447276940157*^9, 
   3.621447278459813*^9}, {3.621447315747851*^9, 3.621447336176682*^9}, {
   3.621447467955649*^9, 3.621447468643762*^9}, {3.6214479089940777`*^9, 
   3.621447947908929*^9}, {3.621449082156744*^9, 3.621449083480784*^9}, 
   3.621452044984508*^9, {3.621555823100525*^9, 3.621555845847617*^9}, {
   3.6215560165188427`*^9, 3.6215560391738443`*^9}, 3.621556156325762*^9, {
   3.621556491142254*^9, 3.621556512007037*^9}, {3.621559783099094*^9, 
   3.6215597941382933`*^9}, {3.6215599743578167`*^9, 3.621559976061116*^9}, {
   3.621560029105731*^9, 3.621560043639518*^9}, {3.621562007555317*^9, 
   3.6215620112686768`*^9}, {3.621562273286336*^9, 3.6215623174237957`*^9}, {
   3.621562536474226*^9, 3.621562536499522*^9}, {3.621562939110033*^9, 
   3.621562940706196*^9}, {3.621563042228271*^9, 3.621563044791209*^9}}],

Cell[CellGroupData[{

Cell["Inicializaci\[OAcute]n", "Section",
 CellChangeTimes->{{3.621559512502644*^9, 3.621559538188548*^9}, {
  3.62156563024118*^9, 3.621565631124432*^9}}],

Cell["\<\
Esto sirve para imprimir polinomios con los t\[EAcute]rminos ordenados de \
acuerdo a la variable\
\>", "Text",
 CellChangeTimes->{{3.621556592034486*^9, 3.621556605006865*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"pretty", "[", 
   RowBox[{"x_", ",", " ", "X_"}], "]"}], " ", ":=", " ", 
  RowBox[{
   RowBox[{
    RowBox[{"HoldForm", "[", 
     RowBox[{"+", "##"}], "]"}], "&"}], "@@", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{"Factor", "[", 
        RowBox[{"#", "\[LeftDoubleBracket]", "2", "\[RightDoubleBracket]"}], 
        "]"}], 
       SuperscriptBox["X", 
        RowBox[{"#", "\[LeftDoubleBracket]", 
         RowBox[{"1", ",", " ", "1"}], "\[RightDoubleBracket]"}]]}], "&"}], "/@", 
     RowBox[{"CoefficientRules", "[", 
      RowBox[{"x", ",", " ", "X"}], "]"}]}], ")"}]}]}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.62155617996028*^9, 3.621556192257752*^9}, {
  3.621556330475955*^9, 3.621556461835833*^9}, {3.6215599539101467`*^9, 
  3.6215599570911713`*^9}}]
}, Open  ]]
},
WindowSize->{1920, 1014},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
ShowSelection->True,
FrontEndVersion->"9.0 for Linux x86 (64-bit) (November 20, 2012)",
StyleDefinitions->Notebook[{
   Cell[
    StyleData[StyleDefinitions -> "Default.nb"]], 
   Cell[
    StyleData["Text"], Background -> 
    RGBColor[0.803921568627451, 0.8509803921568627, 1.]], 
   Cell[
    StyleData["Item"], Background -> 
    RGBColor[0.803921568627451, 0.8509803921568627, 1.]]}, Visible -> False, 
  FrontEndVersion -> "9.0 for Linux x86 (64-bit) (November 20, 2012)", 
  StyleDefinitions -> "PrivateStylesheetFormatting.nb"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[557, 20, 562, 17, 69, "Text"],
Cell[1122, 39, 1040, 20, 111, "Input"],
Cell[2165, 61, 1400, 36, 143, "Text"],
Cell[3568, 99, 1397, 38, 119, "Input"],
Cell[4968, 139, 992, 31, 139, "Text"],
Cell[5963, 172, 761, 15, 64, "Input"],
Cell[6727, 189, 398, 11, 84, "Text"],
Cell[7128, 202, 517, 14, 63, "Input"],
Cell[7648, 218, 389, 10, 84, "Text"],
Cell[8040, 230, 1919, 52, 243, "Input"],
Cell[9962, 284, 764, 23, 117, "Text"],
Cell[10729, 309, 2692, 69, 309, "Input"],
Cell[13424, 380, 389, 12, 84, "Text"],
Cell[13816, 394, 1561, 43, 160, "Input"],
Cell[15380, 439, 134, 1, 64, "Text"],
Cell[15517, 442, 1579, 29, 44, "Input"],
Cell[CellGroupData[{
Cell[17121, 475, 155, 2, 113, "Section"],
Cell[17279, 479, 187, 4, 65, "Text"],
Cell[17469, 485, 848, 23, 51, "Input",
 InitializationCell->True]
}, Open  ]]
}
]
*)

(* End of internal cache information *)
